//compile: csc test.cs repcoder.cs

using System;

class App
{
 public static void Main()
   {
// Init repcoder
    if( !Repcoder.init() )
      {
       Console.WriteLine("Repcoder.init() error ...");
       return;
      }

// Create RCALC object
    RCALC rc = new RCALC();

    string AlgTxt = 
    "INPUT {" +
    "FLOAT x;" +
    "FLOAT y;" +
    "}" +
    "FLOAT z = x + y;" +
    "OUTPUT {" +
    "FLOAT Out1 = z*z;" +
    "FLOAT Out2 = sqrt(x + y);" +
    "}";

// Compile RCALC object
    bool ok = rc.Compile(AlgTxt);
    if( !ok )
      {
       RCALC.ShowError((IntPtr)0);
       Repcoder.exit();
       return;
      }

// Show compiled text in the Console
    string compstr = rc.CompiledText(true);
    if( compstr != String.Empty ) 
      { 
       Console.WriteLine("\n******* Compiled text ***************\n");
       Console.WriteLine(compstr);
       Console.WriteLine("\n******* End of compiled text ********\n");
      }

// Get and print the number of output values
    int nOut = rc.OutputCount();
    Console.WriteLine("nOut = " + nOut);

// Execute with some input values: x = 3.14159, y = 2.71
    ok = rc.Execute("3.14159###2.71");
    if( !ok )
      {
       RCALC.ShowError((IntPtr)0);
       Repcoder.exit();
       return;
      }

// Print the results
    Console.WriteLine("Out1 = " + rc.OutString(1));
    Console.WriteLine("Out2 = " + rc.OutString(2) + "\n");

// Get the results to host variables
    double Out1 = rc.OutDouble(1);
    double Out2 = rc.OutDouble(2);
    Console.WriteLine("Out1 = " + Out1 + ", Out2 = " + Out2);

// Exit repcoder
    Repcoder.exit();
   }
}

