//compile: csc thrtest.cs repcoder.cs

using System;
using System.Threading;

class MyThrParam
{
public int nr;
public RCALC rc;

public MyThrParam(int a_nr, RCALC a_rc)
  {
   nr = a_nr;
   rc = a_rc;
  }
}
//--------------

class App
{
 const int NUM_THREADS = 10; // number of threads
 const int N_LOOP = 50000; // number of WHILE loops
 
// Thread procedure
 public static void ThrProc(object data)
   {
    MyThrParam par = (MyThrParam)data;

// Make a copy of the primary (compiled) object
    RCALC rc = new RCALC(par.rc);
    if( !rc.IsValid() ) { RCALC.ShowError((IntPtr)0); return; }

// Set the 2 input values for the RCALC script
    string InputValues = par.nr + "###" + N_LOOP;

// Execute the RCALC code
    rc.Execute(InputValues);

// Show RCALC error (if any)
    RCALC.ShowError((IntPtr)0);
   }

 public static void Main()
   {
// Init repcoder
    if( !Repcoder.init() )
      {
       Console.WriteLine("Repcoder.init() error ...");
       return;
      }

// Create the primary RCALC object in the main thread
    RCALC rc = new RCALC();
    
// Compile the object (only once !!!)
    bool ok = rc.CompileFile(".\\Samples\\threads.txt", 0);
    if( !ok )
      {
       RCALC.ShowError((IntPtr)0);
       Repcoder.exit();
       return;
      }

    Console.WriteLine("\nStarting 11 threads.\nPlease wait ...");

// Allocate input structures for child threads
    MyThrParam[] myparams = new MyThrParam[NUM_THREADS];
    Thread[] threads = new Thread[NUM_THREADS];

// Start the child threads
    for(int i=0; i<NUM_THREADS; i++)
      {
       myparams[i] = new MyThrParam(i+1, rc);
       threads[i] = new Thread(App.ThrProc);
       threads[i].Start(myparams[i]);
      }

// Execute the RCALC code also in the main thread:
// ... make also a copy of the primary (compiled) object
    RCALC rc2 = new RCALC(rc);
// ... set the 2 input values for the RCALC script
    string InputValues = (NUM_THREADS+1) + "###" + N_LOOP;
// Execute the RCALC code
    rc2.Execute(InputValues);

// Join the threads
    for(int i=0; i<NUM_THREADS; i++) threads[i].Join();

    Console.WriteLine("\nThe result files were created in the current dir:");
    Console.WriteLine("res_1.txt, res_2.txt, ..., res_11.txt");

// Show RCALC error (if any)
    RCALC.ShowError((IntPtr)0);
    
// Exit repcoder
    Repcoder.exit();
  }
}